﻿Global hf$

Enumeration
  #dbst
  #bdh
  #hexf
  #binprefix
  #perline
  #linenum
  #numst
  #nstep
  #b2i
  #ont
  #decz
  #aus
  #cpas
EndEnumeration

Procedure dob2i(filn.s)
  bpl.l=Val(GetGadgetText(#perline)); bytes per line
  linen.l=Val(GetGadgetText(#numst)); line number
  linest.l=Val(GetGadgetText(#nstep)); number step
  If bpl
    If ReadFile(0,filn)
      inc$=""
      bc.l=1                             ;bytecounter
      
      ;     If GetGadgetState(#linenum)=1
      ;       inc$=Str(linen)+" "+GetGadgetText(#dbst)
      ;     EndIf
      While Not Eof(0)
        
        If bc=1 And Not Eof(0)
          If GetGadgetState(#linenum)=1
            ;inc$=inc$+Str(linen)+" "+GetGadgetText(#dbst)
            inc$=inc$+Str(linen);+GetGadgetText(#dbst)
          EndIf
          inc$+GetGadgetText(#dbst)
        EndIf
        d.a=ReadAsciiCharacter(0)
        
        numb$=""
        Select GetGadgetState(#bdh)
          Case 0: ;bin
            numb$=GetGadgetText(#binprefix)+RSet(Bin(d),8,"0")
          Case 1: ; dec
            dz.l=Val(GetGadgetText(#decz))
            numb$=Str(d)
            If dz
              numb$=RSet(numb$,dz,"0")
            EndIf
          Case 2: ; hex
            numb$=RSet(Hex(d),2,"0")
            If hf$<>""
              he.l=GetGadgetState(#hexf)+1
              numb$=ReplaceString(StringField(hf$, he, "|"),"%s",numb$)
            EndIf
        EndSelect
        inc$+numb$
        
        ;If Not Eof(0)
        If bc<bpl Or GetGadgetState(#cpas)
          If Not Eof(0)
            inc$+","
          EndIf
;         ElseIf GetGadgetState(#cpas)
;           If Not Eof(0)
;             inc$+","
;           EndIf
        EndIf
        ;EndIf
        
        bc+1
        If bc>bpl
          bc=1
          If GetGadgetState(#linenum)=2
            inc$=inc$+";"+Str(linen)
          EndIf
          inc$+#CRLF$
          linen+linest
          
          ;           If Not Eof(0)
          ;             If GetGadgetState(#linenum)=1
          ;               inc$=inc$+Str(linen)+" "+GetGadgetText(#dbst)
          ;             EndIf
          ;           EndIf
          
        EndIf
      Wend
      
      SetGadgetText(#b2i,inc$)
      CloseFile(0)
      ;Debug GetFilePart(filn,#PB_FileSystem_NoExtension)
      fp.s=GetPathPart(filn)
      fna.s=GetFilePart(filn,#PB_FileSystem_NoExtension)
      If fp=""
        fp=GetCurrentDirectory()
      EndIf
      If GetGadgetState(#aus)
        If CreateFile(0,fp+fna+".inc")
          WriteString(0,inc$)
          CloseFile(0)
        Else
          MessageRequester("Error", "cannot write"+#CRLF$+GetFilePart(filn,#PB_FileSystem_NoExtension)+".inc", #PB_MessageRequester_Ok)
        EndIf
      EndIf
    Else
      MessageRequester("Error", "cannot read:"+#CRLF$+flin, #PB_MessageRequester_Ok)
    EndIf
  Else
    MessageRequester("Error", "Wrong parametr 'bytes per line':"+Str(bpl), #PB_MessageRequester_Ok)
  EndIf
EndProcedure

If OpenWindow(0, 0, 0, 600, 400, "Bin2inc 0.9", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  ComboBoxGadget(#dbst, 5, 5, 180, 20):GadgetToolTip(#dbst,"data prefix")
  StringGadget(#perline, 190, 5, 60, 20, "10",#PB_String_Numeric|#ES_CENTER):GadgetToolTip(#perline,"Bytes per line")
  
  ComboBoxGadget(#linenum, 5, 30, 120, 20):GadgetToolTip(#linenum,"line number")
  StringGadget(#numst, 130, 30, 50, 20, "0",#PB_String_Numeric|#ES_CENTER):GadgetToolTip(#numst,"Start From")
  StringGadget(#nstep, 185, 30, 50, 20, "1",#PB_String_Numeric|#ES_CENTER):GadgetToolTip(#nstep,"Number step")
  
  ComboBoxGadget(#bdh, 10, 55, 90, 20):GadgetToolTip(#bdh,"Bin Dec Hex")
  ComboBoxGadget(#hexf, 110, 55, 50, 20):GadgetToolTip(#hexf,"Hex Format")
  StringGadget(#binprefix, 170, 55, 50, 20, "%",#ES_CENTER):GadgetToolTip(#binprefix,"Binary prefix")
  StringGadget(#decz, 225, 55, 50, 20, "0",#PB_String_Numeric|#ES_CENTER):GadgetToolTip(#decz,"Decimal autocomplete")
  
  
  CheckBoxGadget(#ont, 510, 0, 50, 20, "T"):GadgetToolTip(#ont,"Stay on top")
  CheckBoxGadget(#aus, 510, 20, 50, 20, "A"):GadgetToolTip(#aus,"Autosave")
  CheckBoxGadget(#cpas, 510, 40, 50, 20, "C"):GadgetToolTip(#cpas,"Arrays for C/Pascal")
  
  StringGadget(#b2i, 10, 80, 580, 310, "hujcy",#ES_MULTILINE|#ES_AUTOVSCROLL|#WS_VSCROLL|#WS_HSCROLL|#ESB_DISABLE_LEFT|#ESB_DISABLE_RIGHT)
  :GadgetToolTip(#b2i,"Drag'n'drop file to start")
  EnableGadgetDrop(#b2i,#PB_Drop_Files,#PB_Drag_Copy)  
  
  If OpenPreferences("b2i.ini")
    
    PreferenceGroup("general")
    db$=ReadPreferenceString("dbstyle","")
    hf$=ReadPreferenceString("hext","")
    SetGadgetText(#binprefix,ReadPreferenceString("binprefix",""))
    
    
    PreferenceGroup("user")
    linenum.l=ReadPreferenceLong("linenum",0)
    nbase.l=ReadPreferenceLong("nbase",0)
    dprefix.l=ReadPreferenceLong("dprefix",0)
    hexf.l=ReadPreferenceLong("hexf",0)
    SetGadgetText(#perline,ReadPreferenceString("bpl","10"))
    
    SetGadgetText(#numst,ReadPreferenceString("numberstart","10"))
    SetGadgetText(#nstep,ReadPreferenceString("numberstep","1"))
    
    SetGadgetText(#decz,ReadPreferenceString("decimalz","0"))
    SetGadgetState(#aus,ReadPreferenceLong("autosave",0))
    SetGadgetState(#ont,ReadPreferenceLong("ontop",0))
    SetGadgetState(#cpas,ReadPreferenceLong("array",0))
    ClosePreferences()
  EndIf
  If GetGadgetState(#ont)
    StickyWindow(0,1)
  EndIf
  
  ;setup data
  AddGadgetItem(#linenum,0,"No line number")
  AddGadgetItem(#linenum,1,"Number first")
  AddGadgetItem(#linenum,2,"Number after ;")
  SetGadgetState(#linenum,linenum)
  
  AddGadgetItem(#bdh,0,"Bin")
  AddGadgetItem(#bdh,1,"Dec")
  AddGadgetItem(#bdh,2,"Hex")
  SetGadgetState(#bdh,nbase)
  
  If db$<>""
    For i=0 To CountString(db$,"|")
      AddGadgetItem( #dbst,i,StringField(db$, i+1, "|") )
    Next i
  EndIf
  SetGadgetState(#dbst,dprefix)
  
  If hf$<>""
    For i=0 To CountString(hf$,"|")
      h$=ReplaceString(StringField(hf$, i+1, "|"),"%s","BE")
      AddGadgetItem( #hexf,i,h$ )
    Next i
  EndIf
  SetGadgetState(#hexf,hexf)
  
  If CountProgramParameters()
    dob2i( ProgramParameter(0))
    End
  EndIf
  
  Repeat
    ev=WaitWindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE)=-32767
      Break
    EndIf
    Select ev
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #ont: StickyWindow(0,GetGadgetState(#ont))
        EndSelect
        
      Case #PB_Event_GadgetDrop
        t$ = EventDropFiles()
        t$ = StringField(t$, 1, Chr(10))
        dob2i(t$)
    EndSelect
    
  Until ev = #PB_Event_CloseWindow
EndIf

If OpenPreferences("b2i.ini")
  
  PreferenceGroup("general")
  WritePreferenceString("binprefix",GetGadgetText(#binprefix) )
  
  
  PreferenceGroup("user")
  WritePreferenceLong("linenum",GetGadgetState(#linenum) )
  WritePreferenceLong("nbase",GetGadgetState(#bdh) )
  WritePreferenceLong("dprefix",GetGadgetState(#dbst) )
  WritePreferenceLong("hexf",GetGadgetState(#hexf) )
  
  WritePreferenceLong("autosave",GetGadgetState(#aus) )
  WritePreferenceLong("ontop",GetGadgetState(#ont) )
  WritePreferenceLong("array",GetGadgetState(#cpas) )
  
  
  WritePreferenceString("decimalz",GetGadgetText(#decz) )
  WritePreferenceString("bpl",GetGadgetText(#perline) )
  WritePreferenceString("numberstart",GetGadgetText(#numst) )
  WritePreferenceString("numberstep",GetGadgetText(#nstep) )
  ClosePreferences()
EndIf

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 39
; FirstLine = 30
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = binary1.ico
; Executable = b2i.exe